routes/web.php
<?php

use App\Http\Controllers\CategoryController;
use App\Http\Controllers\CountryController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::prefix('cms/admin')->group(function () {
    Route::view('/', 'cms.parent');
    Route::resource('categories', CategoryController::class);
    Route::resource('countries', CountryController::class);
});

app/Models/country.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class country extends Model
{
    use HasFactory;
}

app/Http/Controllers/CountryController.php
<?php

namespace App\Http\Controllers;

use App\Models\country;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Symfony\Component\HttpFoundation\Response;

class CountryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $data = country::all();
        return response()->view('cms.countries.index', ['countries' => $data]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return response()->view('cms.countries.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validator = Validator($request->all(), [
            'name' => 'required|string|min:3|max:40',
        ]);
        if (!$validator->fails()) {
            //TODO :SUCCESS
            $country = new country();
            $country->name = $request->get('name');
            $isSaved = $country->save();
            return response()->json(['message' => $isSaved ? 'counrty created successfully'
                : 'failed to create'], $isSaved ? response::HTTP_CREATED : response::HTTP_BAD_REQUEST);
        } else {
            //TODO: FAILED
            return response()->json([
                'message' => $validator->getMessageBag()->first()
            ], Response::HTTP_BAD_REQUEST);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\country  $country
     * @return \Illuminate\Http\Response
     */
    public function show(country $country)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\country  $country
     * @return \Illuminate\Http\Response
     */
    public function edit(country $country)
    {
        return response()->view('cms.countries.edit', ['country' => $country]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\country  $country
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, country $country)
    {
        $validator = Validator($request->all(), [
            'name' => 'required|string|min:3|max:40',
        ]);
        if (!$validator->fails()) {
            //TODO SUCCCESS
            $country->name = $request->get('name');
            $isSaved = $country->save();
            return response()->json(
                [
                    'message' => $isSaved ? 'counrty Updated successfully' : 'failed to Update'
                ],
                $isSaved ? Response::HTTP_OK : Response::HTTP_BAD_REQUEST
            );
        } else {

            return response()->json([
                'message' => $validator->getMessageBag()->first()
            ], Response::HTTP_BAD_REQUEST);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\country  $country
     * @return \Illuminate\Http\Response
     */
    public function destroy(country $country)
    {
        $isDeleted = $country->delete();
        return response()->json([
            'icon' => $isDeleted ? 'success' : 'danger',
            'title' => $isDeleted ? 'the country is deleted' : 'the delete is failed'
        ], $isDeleted ? Response::HTTP_OK : Response::HTTP_BAD_REQUEST);
    }
}

resources/views/cms/countries/create.blade.php
@extends('cms.parent')

@section('title','Countries')

@section('page-large-title','Countries')
@section('page-small-title','create')

@section('content')
    
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Create Country</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form method="POST" id="create-form">
            @csrf   
                <div class="card-body">
                  <div class="form-group">
                    <label for="name">Name</label>
                      
                    <input type="text" name="name" class="form-control" id="name" placeholder="Enter Name">
                  </div>
                </div>
            </div>
                <!-- /.card-body -->

                <div class="card-footer">
                  <button type="button" onclick="createItem()" class="btn btn-primary">Submit</button>
                </div>
              </form>
          </div>
            <!-- /.card -->

        </div>
          <!--/.col (left) -->
  
        </div>
        <!-- /.row -->
    </section>
    <!-- /.content -->
@endsection

@section('styles')
    
@endsection

@section('scripts')

    <script> 
      function createItem(){ 
          let data = { name:document.getElementById('name').value }
          store('/cms/admin/countries',data);
      }
    </script>
@endsection

resources/views/cms/countries/edit.blade.php
@extends('cms.parent')

@section('title','Countries')

@section('page-large-title','Countries')
@section('page-small-title','update')

@section('content')
    
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">update Country</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form method="POST">
            @csrf   
                <div class="card-body">
                  <div class="form-group">
                    <label for="name">Name</label>
                      
                    <input type="text" name="name" value="{{$country->name}}"  class="form-control" id="name" placeholder="Enter Name">
                  </div>
                  
                </div>
                <!-- /.card-body -->

                <div class="card-footer">
                  <button type="button" onclick="updateItem({{$country->id}})" class="btn btn-primary">Update</button>
                </div>
              </form>
            </div>
            <!-- /.card -->

          </div>
          <!--/.col (left) -->
  
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('styles')
    
@endsection

@section('scripts')
    <script>
      function updateItem(id){
        let data = {
          name : document.getElementById('name').value
        }
        update('/cms/admin/countries/'+id , data , '/cms/admin/countries')
      };
    </script>
@endsection

resources/views/cms/countries/index.blade.php
@extends('cms.parent')

@section('title','countries')

@section('page-large-title','countries')
@section('page-small-title','Index')

@section('content')
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-md-12">
            <div class="card">
              <div class="card-header">
                <h3 class="card-title">Bordered Table</h3>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                  @if (session()->has('Umessage'))

                     <div class="alert alert-success alert-dismissible">
                  <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                  <h5><i class="icon fas fa-check"></i> success!</h5>
                   {{session()->get('Umessage')}}        {{-- {{session('message')}} --}}

                    </div>
                      
                  @endif
                <table class="table table-bordered table-striped table-hover">
                  <thead>
                    <tr>
                      <th style="width: 10px">#</th>
                      <th>Name</th>
                      <th>Created At</th>
                      <th>Updated At</th>
                      <th>Settings</th>

                    </tr>
                  </thead>
                  <tbody>
                      @foreach ($countries as $country)
                          <tr>
                      <td>{{$country->id}}</td>
                      <td>{{$country->name}}</td>
                      <td>{{$country->created_at->format('y-m-d H:ma')}}</td>
                      <td>{{$country->updated_at->format('y-m-d H:ma')}}</td>
                      <td>

                          <div class="btn-group">
                        <a href="{{route('countries.edit', $country->id)}}" class="btn btn-info">
                          <i class="fas fa-edit"></i>
                        </a>

                        <a onclick="deleteCountry({{$country->id}}, this)" class="btn btn-danger">
                          <i class="fas fa-trash"></i>
                        </a>

                         {{-- cms/admin/countries/{country} --}}
                        {{-- <form method="POST" action="{{route('countries.destroy',$country->id)}}">
                            @csrf
                            @method('DELETE')
                            <button type="submit" class="btn btn-danger">
                          <i class="fas fa-trash"></i>
                        </button>
                        </form> --}}
                        
                        
                        </div>
                      </td>
                    </tr>
                 
                      @endforeach
                    
                  </tbody>
                </table>
              </div>
              
   
            </div>
            <!-- /.card -->

            <!-- /.card -->
          </div>
         
          <!-- /.col -->
        </div>
        
      </div><!-- /.container-fluid -->
    </section>
@endsection

@section('styles')
    
@endsection

@section('scripts')

    <script>
      function deleteCountry(id, raference){
        confirmDestroy('/cms/admin/countries',id, raference)
      }
    </script>
@endsection